/*
   HARK Library
   Copyright (C) 2021 Honda Research Institute Japan Inc.
 */

#include "hark-lib/node/SourceTracker.h"

namespace hark
{
namespace node
{
    SourceTracker::SourceTracker():
        NodeDef("SourceTracker")
    {
        *this
            << Terminal::in("INPUT")
            >> Terminal::out("OUTPUT");
    }

    void
    SourceTracker::reset()
    {
    }

    bool
    SourceTracker::operator () (size_t count, InputDataBundle &input, OutputDataBundle &output)
    {
        output["OUTPUT"].push(input["INPUT"].last());
        return true;
    }
}
}

/* end of file */
